/*Programma di esempio, gestito in I2C, che scrive una stringa sulla eeprom esterna della scheda freedom, 
  ne legge il contenuto e lo visualizza sul display lcd. Si  fatto uso di un array monodimensionale.
  (per quelli bidimensionali mi sto attrezzando!!!!!)
  
  Il programma funziona anche sostituendo la stringa con i singoli caratteri espressi in esadecimale. 
  
  NOTA: Dopo avere fatto il build all del progetto, dare un colpo di erase prima della programmazione. Ho notato 
  che a volte l'eeprom non viene scritta e mantiene in memoria i valori dovuti alla precedente programmazione. 
  In altre parole, non fidarsi dell'erase che viene effettuato in automatico prima della programmazione.
  
  Marcello Pinna 11/10/2011
  Tratto da un lavoro di Mauro Laurenti 
*/

#include <p18f4550.h>

#define LCD_DEFAULT
#include "LCD_44780.h"
#include "i2cEEPROM.h"
#include "delay.h"

#pragma config FOSC = HS 	
#pragma config WDT = OFF 	
#pragma config LVP = OFF 	
#pragma config PBADEN = OFF 

//OSC = HS  	Impostato per lavorare ad alta frequenza 
//WDT = OFF		Disabilito il watchdog timer
//LVP = OFF 	Disabilito programmazione LVP
//PBADEN = OFF Disabilito gli ingressi analogici


// Variabile che definisce la grandezza dell'array
#define ADDRESS 16

	// Variabile per salvare il dato di ritorno 
	unsigned char data = 0; 
	
	// Contatore per le celle di memoria della eeprom
	unsigned char i = 0; 
	 
	// Definizione dell'array ESADECIMALE della frase "WRITE COMPLETED"
	//unsigned char mioArray []= {0x57,0x52,0x49,0x54,0x45,0x20,0X20,0x43,0x4F,0x4D,0x50,0x4C,0x45,0x54,0x45,0x44};
		
	// Definizione dell'array STRINGA
	unsigned char mioArray []="SCRITTURA FINITA";


void main (void){
		
	// Imposto PORTA tutti ingressi 
	LATA = 0x00; 
 	TRISA = 0xFF;

	// Imposto PORTB tutti ingressi
 	LATB = 0x00; 
 	TRISB = 0xFF;

	// Imposto PORTC tutti ingressi, RC1 come output
 	LATC = 0x00;    	 
 	TRISC = 0b11111101;
 	
	// Imposto PORTD tutte uscite
 	LATD = 0x00;  
 	TRISD = 0x00;

	// Imposto PORTE tutti ingressi
 	LATE = 0x00;
 	TRISE = 0xFF;
 	
 	// Imposto il quarzo per la libreria delay
 	setQuartz (20);
	
	// Inizializza il modulo I2C a 400KHz @20MHz
	OpenI2C(MASTER, SLEW_ON);	
	SSPADD = 12; 
	
/***********************************  SCRITTURA  ****************************************************/

	// Inizializzo il mio Array
	for (i = 0; i < ADDRESS; i++) {    /* per colpa della mancanza delle parentesi grafe, leggi la mia
									      infinita sbadataggine, non scriveva nulla: un giorno perso!!! 
									   */
									
	// Scrivo nelle locazioni di memoria il contenuto dell'array
	writeI2C_EEPROM (0xA0, i, mioArray[i]);	
		delay_ms(10);
	
	}
	
/****************************************************************************************************/

	OpenLCD (20);
 	BacklightLCD (TURN_ON);	

/***********************************   LETTURA  ****************************************************/	
	// Inizializzo il mio Array
	for (i = 0; i < ADDRESS; i++) 
		mioArray[i] = i;
	
	for (i=0; i < ADDRESS; i++) {
	
	// Leggo le locazioni di memoria in cui sono contenuti i caratteri. Per fare questo ho dovuto levare
	// l'operatore &
	readI2C_EEPROM (0xA0, mioArray[i], data);	
		delay_ms(10);
	WriteVarLCD (data);
	
	}
	
	// Ciclo infinito
 	while (1) {	 	
	 	
 	}
}

